
import { Subject } from 'rxjs';
import { GridView9Base } from '@/studio-core';
import HRPostRelService from '@/service/hrpost-rel/hrpost-rel-service';
import HRPostRelAuthService from '@/authservice/hrpost-rel/hrpost-rel-auth-service';
import GridView9Engine from '@engine/view/grid-view9-engine';
import HRPostRelUIService from '@/uiservice/hrpost-rel/hrpost-rel-ui-service';
import CodeListService from "@service/app/codelist-service";


/**
 * 职位关系表格视图视图基类
 *
 * @export
 * @class HRPostRelV_001Base
 * @extends {GridView9Base}
 */
export class HRPostRelV_001Base extends GridView9Base {
    /**
     * 视图对应应用实体名称
     *
     * @protected
     * @type {string}
     * @memberof HRPostRelV_001Base
     */
    protected appDeName: string = 'hrpostrel';

    /**
     * 应用实体主键
     *
     * @protected
     * @type {string}
     * @memberof HRPostRelV_001Base
     */
    protected appDeKey: string = 'hrpostrelid';

    /**
     * 应用实体主信息
     *
     * @protected
     * @type {string}
     * @memberof HRPostRelV_001Base
     */
    protected appDeMajor: string = 'hrpostrelname';

    /**
     * 实体服务对象
     *
     * @type {HRPostRelService}
     * @memberof HRPostRelV_001Base
     */
    protected appEntityService: HRPostRelService = new HRPostRelService;

    /**
     * 实体权限服务对象
     *
     * @type HRPostRelUIService
     * @memberof HRPostRelV_001Base
     */
    public appUIService: HRPostRelUIService = new HRPostRelUIService(this.$store);


    /**
     * 计数器服务对象集合
     *
     * @protected
     * @type {Array<*>}
     * @memberof HRPostRelV_001Base
     */    
    protected counterServiceArray: Array<any> = [];

    /**
     * 视图模型数据
     *
     * @protected
     * @type {*}
     * @memberof HRPostRelV_001Base
     */
    protected model: any = {
        srfCaption: 'entities.hrpostrel.views.v_001.caption',
        srfTitle: 'entities.hrpostrel.views.v_001.title',
        srfSubTitle: 'entities.hrpostrel.views.v_001.subtitle',
        dataInfo: ''
    }

    /**
     * 容器模型
     *
     * @protected
     * @type {*}
     * @memberof HRPostRelV_001Base
     */
    protected containerModel: any = {
        view_grid: { name: 'grid', type: 'GRID' },
    };


	/**
     * 视图唯一标识
     *
     * @protected
     * @type {string}
     * @memberof ViewBase
     */
	protected viewtag: string = '4f567c340cbb4271d44543b278d29d0f';


    /**
     * 视图引擎
     *
     * @public
     * @type {Engine}
     * @memberof HRPostRelV_001Base
     */
    public engine: GridView9Engine = new GridView9Engine();

    /**
     * 引擎初始化
     *
     * @public
     * @memberof HRPostRelV_001Base
     */
    public engineInit(): void {
        this.engine.init({
            view: this,
            opendata: (args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any) => {
                this.opendata(args,fullargs, params, $event, xData);
            },
            newdata: (args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any) => {
                this.newdata(args,fullargs, params, $event, xData);
            },
            grid: this.$refs.grid,
            keyPSDEField: 'hrpostrel',
            majorPSDEField: 'hrpostrelname',
            isLoadDefault: true,
        });
    }

    /**
     * grid 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRPostRelV_001Base
     */
    public grid_selectionchange($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'selectionchange', $event);
    }

    /**
     * grid 部件 beforeload 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRPostRelV_001Base
     */
    public grid_beforeload($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'beforeload', $event);
    }

    /**
     * grid 部件 rowdblclick 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRPostRelV_001Base
     */
    public grid_rowdblclick($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'rowdblclick', $event);
    }

    /**
     * grid 部件 remove 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRPostRelV_001Base
     */
    public grid_remove($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'remove', $event);
    }

    /**
     * grid 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof HRPostRelV_001Base
     */
    public grid_load($event: any, $event2?: any): void {
        this.engine.onCtrlEvent('grid', 'load', $event);
    }

    /**
     * 打开新建数据视图
     *
     * @param {any[]} args
     * @param {*} [params]
     * @param {*} [fullargs]
     * @param {*} [$event]
     * @param {*} [xData]
     * @memberof HRPostRelV_001
     */
    public newdata(args: any[],fullargs?:any[], params?: any, $event?: any, xData?: any) {
        let localContext:any = null;
        let localViewParam:any =null;
        const data: any = {};
        if(args[0].srfsourcekey){
            data.srfsourcekey = args[0].srfsourcekey;
        }
        let tempContext = JSON.parse(JSON.stringify(this.context));
        delete tempContext.hrpostrel;
        if(args.length >0){
            Object.assign(tempContext,args[0]);
        }
        let deResParameters: any[] = [];
        if(tempContext.hrpost && true){
            deResParameters = [
            { pathName: 'hrposts', parameterName: 'hrpost' },
            ]
        }
        const parameters: any[] = [
            { pathName: 'hrpostrels', parameterName: 'hrpostrel' },
            { pathName: 'editview', parameterName: 'editview' },
        ];
        const _this: any = this;
        const openIndexViewTab = (data: any) => {
            const _data: any = { w: (new Date().getTime()) };
            Object.assign(_data, data);
            const routePath = this.$viewTool.buildUpRoutePath(this.$route, tempContext, deResParameters, parameters, args, _data);
            this.$router.push(routePath);
        }
        openIndexViewTab(data);
    }


    /**
     * 打开编辑数据视图
     *
     * @param {any[]} args
     * @param {*} [params]
     * @param {*} [fullargs]
     * @param {*} [$event]
     * @param {*} [xData]
     * @memberof HRPostRelV_001
     */
    public opendata(args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any) {
        const localContext: any = null;
        const localViewParam: any =null;
        const data: any = {};
        let tempContext = JSON.parse(JSON.stringify(this.context));
        if(args.length >0){
            Object.assign(tempContext,args[0]);
        }
        let deResParameters: any[] = [];
        if(tempContext.hrpost && true){
            deResParameters = [
            { pathName: 'hrposts', parameterName: 'hrpost' },
            ]
        }
        const parameters: any[] = [
            { pathName: 'hrpostrels', parameterName: 'hrpostrel' },
            { pathName: 'editview', parameterName: 'editview' },
        ];
        const _this: any = this;
        const openIndexViewTab = (data: any) => {
            const routePath = this.$viewTool.buildUpRoutePath(this.$route, tempContext, deResParameters, parameters, args, data);
            this.$router.push(routePath);
        }
        openIndexViewTab(data);
    }



    /**
     * 表格行数据默认激活模式
     * 0 不激活
     * 1 单击激活
     * 2 双击激活
     *
     * @protected
     * @type {(0 | 1 | 2)}
     * @memberof HRPostRelV_001Base
     */
    protected gridRowActiveMode: 0 | 1 | 2 = 0;
}